def generate_subsets(i, sol, elements):
    # Базовый вариант
    if i == len(elements):
        # Печать полного решения
        print_subset_binary(sol, elements)
    else:
        # Генерация элементов-кандидатов
        for k in range(0, 2):

            # Включить кандидата в частное решение
            sol[i] = k

            # Генерация элемента в позиции i+1
            generate_subsets(i + 1, sol, elements)

            # Удалить кандидата из частного решения
            sol[i] = None  # по желанию


def generate_subsets_wrapper(elements):
    sol = [None] * (len(elements))
    generate_subsets(0, sol, elements)


def print_subset_binary(sol, elements):
    no_elements = True
    print('{', end='')
    for i in range(0, len(sol)):
        if sol[i] == 1:
            if no_elements:
                print(elements[i], sep='', end='')
                no_elements = False
            else:
                print(', ', elements[i], sep='', end='')
    print('}')


generate_subsets_wrapper(['a', 'b', 'c'])
